# This is a BitKeeper generated patch for the following project:
# Project Name: Linux kernel tree
# This patch format is intended for GNU patch command version 2.5 or higher.
# This patch includes the following deltas:
#	           ChangeSet	1.930.31.1 -> 1.930.33.1
#	drivers/acpi/resources/rsaddr.c	1.4.1.1 -> 1.4.1.2
#	drivers/acpi/include/actypes.h	1.7.1.3 -> 1.7.1.4
#
# The following is the BitKeeper ChangeSet Log
# --------------------------------------------
# 03/02/14	rusty@rustcorp.com.au	1.930.1.54
# [PATCH] arch_ia64_sn_io_sn1_pcibr.c, typo: the the
# 
# (Included in 2.5)
# From:  James Mayer <james@cobaltmountain.com>
# --------------------------------------------
# 03/02/14	rusty@rustcorp.com.au	1.930.1.55
# [PATCH] misc register audit fix on qtronix
# 
# (Included in 2.5)
# From:  Michael Still <mikal@stillhq.com>
# 
#   This patch corrects an error found whilst auditing the use of misc_register in 2.5.44. misc_register returns 0 on success, and a negative number on failure...
# --------------------------------------------
# 03/02/14	bjorn_helgaas@hp.com	1.930.31.2
# Merge hp.com:/home/helgaas/bk/ia64-extras
# into hp.com:/home/helgaas/bk/linux-ia64-2.4
# --------------------------------------------
# 03/02/14	bjorn_helgaas@hp.com	1.930.30.2
# ia64: whitespace fixes.
# --------------------------------------------
# 03/02/14	bjorn_helgaas@hp.com	1.930.30.3
# Merge hp.com:/home/helgaas/bk/to-marcelo-2.4
# into hp.com:/home/helgaas/bk/linux-ia64-2.4
# --------------------------------------------
# 03/02/14	bjorn_helgaas@hp.com	1.930.32.1
# ia64: add infrastructure for multiple IO port spaces.
# --------------------------------------------
# 03/02/14	rusty@rustcorp.com.au	1.930.1.56
# [PATCH] duplicate header in drivers_bluetooth_hci_h4.c
# 
# (Included in 2.5)
# From:  Brad Hards <bhards@bigpond.net.au>
# 
#   This one is for drivers/bluetooth/hcd_h4.c
#   <linux/config.h> has the normal idempotent construction.
# 
#   Brad
#   - --
#   http://conf.linux.org.au. 22-25Jan2003. Perth, Aust. Tickets booked.
#   -----BEGIN PGP SIGNATURE-----
#   Version: GnuPG v1.0.6 (GNU/Linux)
#   Comment: For info see http://www.gnupg.org
# 
#   iD8DBQE9oCXdW6pHgIdAuOMRAoozAKCq4iPmLzU45ejfERQBf1kjvuxlaQCgxYdk
#   f1OFGho2AZ2isLTYReP8zSM=
#   =+yvg
#   -----END PGP SIGNATURE-----
# --------------------------------------------
# 03/02/14	rusty@rustcorp.com.au	1.930.1.57
# [PATCH] write with buffer>2GB returns broken errno
# 
#   This is a small patch against 2.4.20, to fix wrong behavior
#   buffer>2G write(2) on 64bit platform.
# --------------------------------------------
# 03/02/14	rusty@rustcorp.com.au	1.930.1.58
# [PATCH] misc register audit fix on ppc64's nvram.c
# 
#   This patch corrects an error found whilst auditing the use of misc_register in 2.5.44. misc_register returns 0 on success, and a negative number on failure...
# --------------------------------------------
# 03/02/14	bjorn_helgaas@hp.com	1.930.33.1
# ACPI: Add support for IO port translation attributes in address space descriptors.
# --------------------------------------------
#
diff -Nru a/drivers/acpi/include/actypes.h b/drivers/acpi/include/actypes.h
--- a/drivers/acpi/include/actypes.h	Wed Oct  8 09:06:50 2003
+++ b/drivers/acpi/include/actypes.h	Wed Oct  8 09:06:50 2003
@@ -902,6 +902,8 @@
 #define ACPI_ISA_ONLY_RANGES            (u8) 0x02
 #define ACPI_ENTIRE_RANGE               (ACPI_NON_ISA_ONLY_RANGES | ACPI_ISA_ONLY_RANGES)
 
+#define ACPI_SPARSE_TRANSLATION         (u8) 0x03
+
 /*
  *  IO Port Descriptor Decode
  */
@@ -1062,7 +1064,7 @@
 typedef struct
 {
 	u16                         range_attribute;
-	u16                         reserved;
+	u16                         translation_attribute;
 
 } acpi_io_attribute;
 
diff -Nru a/drivers/acpi/resources/rsaddr.c b/drivers/acpi/resources/rsaddr.c
--- a/drivers/acpi/resources/rsaddr.c	Wed Oct  8 09:06:50 2003
+++ b/drivers/acpi/resources/rsaddr.c	Wed Oct  8 09:06:50 2003
@@ -131,6 +131,8 @@
 		if (ACPI_IO_RANGE == output_struct->data.address16.resource_type) {
 			output_struct->data.address16.attribute.io.range_attribute =
 				(u16) (temp8 & 0x03);
+			output_struct->data.address16.attribute.io.translation_attribute =
+				(u16) ((temp8 >> 4) & 0x03);
 		}
 		else {
 			/* BUS_NUMBER_RANGE == Address16.Data->Resource_type */
@@ -329,6 +331,9 @@
 		temp8 = (u8)
 			(linked_list->data.address16.attribute.io.range_attribute &
 			 0x03);
+		temp8 |=
+			(linked_list->data.address16.attribute.io.translation_attribute &
+			 0x03) << 4;
 	}
 
 	*buffer = temp8;
@@ -517,6 +522,8 @@
 		if (ACPI_IO_RANGE == output_struct->data.address32.resource_type) {
 			output_struct->data.address32.attribute.io.range_attribute =
 				(u16) (temp8 & 0x03);
+			output_struct->data.address32.attribute.io.translation_attribute =
+				(u16) ((temp8 >> 4) & 0x03);
 		}
 		else {
 			/* BUS_NUMBER_RANGE == Output_struct->Data.Address32.Resource_type */
@@ -713,6 +720,9 @@
 		temp8 = (u8)
 			(linked_list->data.address32.attribute.io.range_attribute &
 			 0x03);
+		temp8 |=
+			(linked_list->data.address32.attribute.io.translation_attribute &
+			 0x03) << 4;
 	}
 
 	*buffer = temp8;
@@ -900,6 +910,8 @@
 		if (ACPI_IO_RANGE == output_struct->data.address64.resource_type) {
 			output_struct->data.address64.attribute.io.range_attribute =
 				(u16) (temp8 & 0x03);
+			output_struct->data.address64.attribute.io.translation_attribute =
+				(u16) ((temp8 >> 4) & 0x03);
 		}
 		else {
 			/* BUS_NUMBER_RANGE == Output_struct->Data.Address64.Resource_type */
@@ -1100,6 +1112,9 @@
 		temp8 = (u8)
 			(linked_list->data.address64.attribute.io.range_attribute &
 			 0x03);
+		temp8 |=
+			(linked_list->data.address64.attribute.io.translation_attribute &
+			 0x03) << 4;
 	}
 
 	*buffer = temp8;
